//------------------------------------------------------------------------------
//	File:					interface.h
//	Date:					9/19/94
//	Author:				Bretton Wade
//
//	Description:	this file contains the class definition for a 3d user interface
//
//------------------------------------------------------------------------------

#include "point_2d.h"
#include "matrix_3d.h"

#ifndef INTERFACE
#define INTERFACE

//------------------------------------------------------------------------------
//	classes
//------------------------------------------------------------------------------
class	interface																																	//	interface class
{																																								//	begin view definition
	private:																																			//	private interface
	protected:																																		//	protected interface
	public:																																				//	public interface
				interface (void) {}																											//	constructor
virtual	~interface (void);																											//	destructor
virtual	void			Click (const point_2d &pt) = 0;																//	handle a click
virtual	matrix_3d	Drag (const point_2d &pt) = 0;																//	handle a drag
virtual	void			DrawBackground (void) const = 0;															//	draw the interface background
virtual	void			DrawForeground (void) const = 0;															//	draw the interface foreground
};																																							//	end interface class definition

//------------------------------------------------------------------------------

#endif //INTERFACE