//------------------------------------------------------------------------------
//	File:					colors.h
//	Date:					9/19/94
//	Author:				Bretton Wade
//
//	Description:	this file contains color usage declarations
//
//------------------------------------------------------------------------------

#ifndef	COLORS
#define	COLORS

//------------------------------------------------------------------------------
//	variables
//------------------------------------------------------------------------------
//	primary colors
extern	RGBColor	BLACK;																												//	black
extern	RGBColor	WHITE;																												//	white
extern	RGBColor	RED;																													//	red
extern	RGBColor	GREEN;																												//	green
extern	RGBColor	BLUE;																													//	blue
//	process colors
extern	RGBColor	YELLOW;																												//	yellow
extern	RGBColor	CYAN;																													//	cyan
extern	RGBColor	MAGENTA;																											//	magenta
//	greyscale
#define	GREY0			WHITE
extern	RGBColor	GREY1;
extern	RGBColor	GREY2;
extern	RGBColor	GREY3;
extern	RGBColor	GREY4;
extern	RGBColor	GREY5;
extern	RGBColor	GREY6;
extern	RGBColor	GREY7;
extern	RGBColor	GREY8;
extern	RGBColor	GREY9;
extern	RGBColor	GREY10;
extern	RGBColor	GREY11;
extern	RGBColor	GREY12;
extern	RGBColor	GREY13;
extern	RGBColor	GREY14;
#define	GREY15		BLACK
//	hilite colors
extern	RGBColor	HILITE_COLOR;																									//	hilite color
extern	RGBColor	MID_HILITE_COLOR;																							//	middle hilite color
extern	RGBColor	DARK_HILITE_COLOR;																						//	dark hilite color
//	enabled frame colors
#define	FRAME_COLOR	BLACK																												//	the foreground frame color
#define	DISABLED_FRAME_COLOR	GREY8																							//	the foreground disabled frame color
//	3d interface colors
//#define	APPLE_INTERFACE_COLORS
#ifdef	APPLE_INTERFACE_COLORS
#define	GREY				GREY1																												//	normal background
#define	LIGHT_GREY	GREY0																												//	hilite
#define	DARK_GREY		GREY5																												//	shadow
#define	BUTTON_GREY	GREY2																												//	background color for a button
#else
#define	GREY				GREY2																												//	normal background
#define	LIGHT_GREY	GREY1																												//	hilite
#define	DARK_GREY		GREY6																												//	shadow
#define	BUTTON_GREY	GREY3																												//	background color for a button
#endif

//------------------------------------------------------------------------------
//	functions
//------------------------------------------------------------------------------
void	GetHiliteColors (void);																										//	get the system hilite colors

//------------------------------------------------------------------------------

#endif	//COLORS