//------------------------------------------------------------------------------
//	File:					3d look.h
//	Date:					7/20/94
//	Author:				Bretton Wade
//
//	Description:	this file contains declarations related to 3D look drawing.
//
//------------------------------------------------------------------------------

#include	"colors.h"
#include	"3d look.h"

//------------------------------------------------------------------------------
//	Frame a rectangle with a raised edge
//------------------------------------------------------------------------------
void	FrameRectUp (Rect &rect)																									//	frame a rectangle with a 3d look such that it appears to be projecting up
{																																								//	begin
	short	right = rect.right - 1,
			left1 = rect.left,
			left2 = rect.left + 1,
			bottom = rect.bottom - 1;
	RGBBackColor (&BLACK);
	RGBForeColor (&LIGHT_GREY);
	MoveTo (rect.left, rect.bottom - 2);
	LineTo (rect.left, rect.top);
	LineTo (rect.right - 2, rect.top);
	RGBBackColor (&WHITE);
	RGBForeColor (&DARK_GREY);
	MoveTo (right, rect.top + 1);
	LineTo (right, bottom);
	LineTo (rect.left + 1, bottom);
	RGBForeColor (&BLACK);
}																																								//	end

//------------------------------------------------------------------------------
//	Frame a rectangle with a lowered edge
//------------------------------------------------------------------------------
void	FrameRectDown (Rect &rect)																								//	frame a rectangle with a 3d look such that it appears to be projecting up
{																																								//	begin
	short	right = rect.right - 1,
			left1 = rect.left,
			left2 = rect.left + 1,
			bottom = rect.bottom - 1;
	RGBBackColor (&BLACK);
	RGBForeColor (&LIGHT_GREY);
	MoveTo (right, rect.top + 1);
	LineTo (right, bottom);
	LineTo (rect.left + 1, bottom);
	RGBBackColor (&WHITE);
	RGBForeColor (&DARK_GREY);
	MoveTo (rect.left, rect.bottom - 2);
	LineTo (rect.left, rect.top);
	LineTo (rect.right - 2, rect.top);
	RGBForeColor (&BLACK);
}																																								//	end

//------------------------------------------------------------------------------
