//------------------------------------------------------------------------------
//	File:					colors.cp
//	Date:					9/19/94
//	Author:				Bretton Wade
//
//	Description:	this file contains color usage definitions
//
//------------------------------------------------------------------------------

#include "colors.h"

//------------------------------------------------------------------------------
//	variables
//------------------------------------------------------------------------------
//	primary colors
RGBColor	BLACK = {0x0000, 0x0000, 0x0000};																			//	black
RGBColor	WHITE = {0xffff, 0xffff, 0xffff};																			//	white
RGBColor	RED = {0xffff, 0x0000, 0x0000};																				//	red
RGBColor	GREEN = {0x0000, 0xffff, 0x0000};																			//	green
RGBColor	BLUE = {0x0000, 0x0000, 0xffff};																			//	blue
//	process colors
RGBColor	YELLOW = {0xffff, 0xffff, 0x0000};																		//	yellow
RGBColor	CYAN = {0x0000, 0xffff, 0xffff};																			//	cyan
RGBColor	MAGENTA = {0xffff, 0x0000, 0xffff};																		//	magenta
//	greyscale
RGBColor	GREY1 = {0xeeee, 0xeeee, 0xeeee};
RGBColor	GREY2 = {0xdddd, 0xdddd, 0xdddd};
RGBColor	GREY3 = {0xcccc, 0xcccc, 0xcccc};
RGBColor	GREY4 = {0xbbbb, 0xbbbb, 0xbbbb};
RGBColor	GREY5 = {0xaaaa, 0xaaaa, 0xaaaa};
RGBColor	GREY6 = {0x9999, 0x9999, 0x9999};
RGBColor	GREY7 = {0x8888, 0x8888, 0x8888};
RGBColor	GREY8 = {0x7777, 0x7777, 0x7777};
RGBColor	GREY9 = {0x6666, 0x6666, 0x6666};
RGBColor	GREY10 = {0x5555, 0x5555, 0x5555};
RGBColor	GREY11 = {0x4444, 0x4444, 0x4444};
RGBColor	GREY12 = {0x3333, 0x3333, 0x3333};
RGBColor	GREY13 = {0x2222, 0x2222, 0x2222};
RGBColor	GREY14 = {0x1111, 0x1111, 0x1111};
//	hilite colors
RGBColor	HILITE_COLOR = {0xcccc, 0xcccc, 0xffff};															//	hilite color
RGBColor	MID_HILITE_COLOR = {0xaaaa, 0xaaaa, 0xffff};													//	middle hilite color
RGBColor	DARK_HILITE_COLOR = {0x3333, 0x3333, 0x6666};													//	darker hilite color

//------------------------------------------------------------------------------
//	functions
//------------------------------------------------------------------------------
void	GetHiliteColors (void)																										//	get the system hilite colors
{																																								//	begin
	AuxWinHandle	colors;																													//	place to get the system color table
	if (GetAuxWin (0, &colors))																										//	if the retrieval is successful
	{																																							//	begin
		ColorSpec	*csa = (*((*colors)->awCTable))->ctTable;													//	get the array of color specs
		HILITE_COLOR = csa[11].rgb;																									//	copy color 11 (tinge light)
		MID_HILITE_COLOR.red = (csa[11].rgb.red + csa[12].rgb.red) / 2;
		MID_HILITE_COLOR.green = (csa[11].rgb.green + csa[12].rgb.green) / 2;
		MID_HILITE_COLOR.blue = (csa[11].rgb.blue + csa[12].rgb.blue) / 2;
		DARK_HILITE_COLOR = csa[12].rgb;																						//	copy color 12 (tinge dark)
	}																																							//	end
}																																								//	end

//------------------------------------------------------------------------------
