// SecureWindowRef.h, the SecureWindowRef class, useful for generating windows
//	for those who do not use a framework to make windows for them.

// copyright  1995, Macneil Shonle. All rights reserved.

#ifndef __SECUREWINDOWREF__
#define __SECUREWINDOWREF__

#ifndef __SECUREMACPORT__
#include <SecureMacPort.h>
#endif

#include <exception>

		// class SecureWindowRef
class SecureWindowRef : public SecureMacPort {
public:
	SecureWindowRef(const Rect& bounds, short theProc =documentProc, ConstStr255Param ="\p",
		Boolean goAwayFlag =false, Boolean visible =true, WindowRef =WindowRef(-1L),
		long refCon =0, void *wStorage =nil) throw(invalidargument);
	virtual ~SecureWindowRef();
	
	Rect& portRect() const;
	BitMapPtr bitMap() const;
	short width() const;
	short height() const;
	CGrafPtr getMacPort() const;
	GDHandle getMacGD() const;
	virtual operator WindowRef() const;

private:
	WindowRef window;
	SecureWindowRef(const SecureWindowRef&);
	SecureWindowRef& operator=(const SecureWindowRef&);
};

#endif