// depth.h
//
// Library routines for getting and setting the color depth for monitors.
// All of the code originated from Kenneth Worley's Monitor Tricks 1.51 in C++.
// Changed to C by Mark Womack.
//

// Convienent constants

#define kMillionsColors		32
#define kThousandsColors	16
#define	k256Colors			8
#define	k16Colors			4
#define	k4Colors			2
#define	k2Colors			1

#define	kGrayMode			0
#define	kColorMode			1

// Public routines

// MaxScreenDepth returns the maximum bit depth that the monitor is capable of.
extern pascal short	MaxScreenDepth( GDHandle theGDevice );

// Returns true if the monitor supports the given depth
extern pascal Boolean SupportsDepth( GDHandle theGDevice, short aDepth);

// GetScreenDepth returns the current bit depth of this monitor.
extern pascal short GetScreenDepth( GDHandle theGDevice );

// SetScreenDepth changes the bit depth of the screen
extern pascal void	SetScreenDepth( GDHandle theGDevice, short newDepth );

// Returns true if the monitor supports the given mode
extern pascal Boolean SupportsMode( GDHandle theGDevice, short aMode);

// GetScreenMode returns one if the monitor is displaying colors, zero if it's displaying in grays.
extern pascal short GetScreenMode( GDHandle theGDevice );

// SetScreenMode sets this monitor to color if 1 is sent, or grays if zero is sent.
extern pascal void	SetScreenMode( GDHandle theGDevice, short newMode );

// SetScreenModeDepth sets the monitor to the color mode and depth specified.
extern pascal void	SetScreenModeDepth( GDHandle theGDevice, short newDepth, short newMode );
