#pragma once

class fullscreen : public port, public depthChange
{
	public:
		//
		// The first three constructors all work on the default graphics device.
		//
		fullscreen( Boolean erase = true);
		fullscreen( int bitDepth, Boolean erase = true);
		fullscreen( int bitDepth, CTabHandle theColorTable, Boolean erase = true);
		fullscreen( GDHandle theGDHandle, int bitDepth,
							CTabHandle theColorTable, Boolean erase = true);
		~fullscreen();
		void show() const;
		void hide() const;

		void setentries( short start, short count, ColorSpec *theTable) const;

	protected:
		WindowPtr     myWindow;
		CWindowRecord myWindowRecord;
		
	private:
		static int numInstances;
		static short oldMBarHeight;
		static short * const MBarHeight;
		//
		// 941207: thePalette is no longer the preferred way to mesh up the
		// color table, but 'thePalette' is maintained for backward compatibility
		// Note: 'thePalette' is obtained from 'pltt' resource #128 when the first
		// fullscreen instance is created, and shared by all fullscreen instances.
		// 'myPalette' is a palette created from the colortable passed to
		// the constructor. It is private to a fullscreen instance and is
		// discarded by fullscreen::~fullscreen.
		// 
		static PaletteHandle thePalette;

		PaletteHandle myPalette;

		void makeOne( CTabHandle theColorTable, Boolean erase);
};
