typedef struct opts
{
	//
	// User settable:
	//
	long numdots_1;
	long numdots_2;
	long num_noise_1;
	long num_noise_2;
	long lifetime_1;
	long lifetime_2;
	long noise_life_1;
	long noise_life_2;
	long diffusion_1;
	long diffusion_2;
	long switchinterval;
	long stim_type;
	long resolution_type;
	long create_output;
	long fixation_dot;
	long round_frame;
	long flickering;
	//
	// user settable, but should be left alone:
	//
	long d_log;
	long d_rot_dir;
	long d_trans;
	long allow_modifications;
	//
	// Not user settable:
	//
	long stepping;
	long numtimingloops;
} opts;

typedef enum
{
	iRun = 1,		iQuit,			iDefaults,

	iNumDots1,		iNumDots2,		iNumNoiseDots1,	iNumNoiseDots2,

	iLife1,			iLife2,			iNoiseLife1,	iNoiseLife2,
	iDiffusion1,	iDiffusion2,

	iSwitchInterval,

	i_dLog,			i_dTrans,		i_dRotDir,

	iTransparant,	iAnnulus,		iHalves,		iQuarts,
	iEighths,		iCheckers8,		iCheckers16,	iSurprise,

	iFixationDot,	iLogClicks,		iCircularMask,	iFlickering,

	i128x128,		i256x256,		i512x512,		i1024x1024,
	iAllowModifications,
	iStepThrough,

	i_dLogStatic,	i_dTransStatic,	i_dRotDirStatic
} dialogItems;

void PolarToCartesian( double r, double fi, double *x, double *y);
void CartesianToPolar( double x, double y, double *r, double *fi);
