/*
	CTCLGEPane.cp
	
	Think Class Library pane for Graphic Elements
	
	Copyright 1993 by Al Evans. All rights reserved.
	
	12/20/93
*/

#include "CGEPane.h"

//Import to get global mouse coordinates for MouseDownInSensor
extern EventRecord	gLastMouseDown;

void	CGEPane::IGEPane(CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							GEWorldLoader aLoadProc)
{
	Rect	worldRect;
	
	CPane::IPane(anEnclosure, aSupervisor, aWidth, aHeight, 
					aHEncl, aVEncl, sizFIXEDLEFT, sizFIXEDTOP);
	worldRect.left = aHEncl;
	worldRect.top = aVEncl;
	worldRect.right = aHEncl + aWidth;
	worldRect.bottom = aVEncl + aHeight;
	itsGEWorld = NewGEWorld((CWindowPtr) this->macPort, &worldRect, nil, 0, 0);
	FailNIL(itsGEWorld);
	if (aLoadProc)
		(aLoadProc)(itsGEWorld);
	ActivateWorld(itsGEWorld, true);
	SetWantsClicks(true);
}

void	CGEPane::Dispose(void)
{
	DisposeGEWorld(itsGEWorld);
	CPane::Dispose();
}

void	CGEPane::Draw(Rect *area)
{
	DoWorldUpdate(itsGEWorld, true);
}

void	CGEPane::Dawdle(long *maxSleep)
{
	DoWorldUpdate(itsGEWorld, false);
	*maxSleep = 1;
}
void	CGEPane::DoClick(Point hitPt, short modifierKeys, long when)
{

#pragma unused (modifierKeys, when)
	Boolean	throwAway;
	
	LocalToGlobal(&hitPt);
	
	throwAway = MouseDownInSensor(itsGEWorld, hitPt);
}
