/*
	CTCLGEPane.h
	
	Think Class Library pane for Graphic Elements
	
	Copyright 1993 by Al Evans. All rights reserved.
	
	12/20/93
	
	NOTE 8/27/95: 
	
		I created this TCL 1.x pane class during compatibility testing of the initial
		release of Graphic Elements. I have not changed it since then. However, I
		*believe* the only change in the API since then which affects this pane class
		is the change in the parameters to NewGEWorld() (see DispCtrl.h). 
		
												--Al Evans, 8/27/95
*/

#pragma once

#include "CPane.h"
//Include Graphic Elements functions
#include "DispCtrl.h"

CLASS CGEPane;

typedef void (*GEWorldLoader)(GEWorldPtr world);

class CGEPane : public CPane {

public:
	
	GEWorldPtr	itsGEWorld;
	
	//Initialize
	void		IGEPane(CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							GEWorldLoader aLoadProc);
							
	//Override dispose to free GEWorld
	void	Dispose(void);
	
	//Draw in response to update event						
	void		Draw(Rect *area);
	
	//Need a hit every tick to run animation
	void		Dawdle(long *maxSleep);
	
	//Let Graphic Elements handle mouse click
	void		DoClick(Point hitPt, short modifierKeys, long when);

};

