/*
	File:		LColorPickerEvents.cp

	Contains:	PowerPlant attachment allowing LColorPicker
				to handle events.
			
	Written by: Chris Thomas

	Copyright:	 1995 Chris K. Thomas. All Rights Reserved.

	Change History (most recent first):
	 			8/26/95		ckt		Created
	 			
	Usage:
		myPickerEvents = new LColorPickerEvents(myColorPicker);
		...
		myApplication->AddAttachment(myPickerEvents, true);
*/

#include "LColorPickerEvents.h"
#include "LColorPicker.h"
#include <LView.h>
//#include <UQDGlobals.h>

void LColorPickerEvents::ExecuteSelf(MessageT inMessage, void *ioParam)
{
	if(inMessage != msg_Event)
	{
		SetExecuteHost(true);
		return;
	}
		
	EventRecord	*ourEvent = (EventRecord*)ioParam;
	
	short action;
		
	action = mPicker->HandleEvent(ourEvent);
	
	if(action == kDidNothing)
	{
		SetExecuteHost(true);
	}
	else
		SetExecuteHost(false);	
		
		
}
