/*
	File:		PPColorApp.cp
	
	Contains:	Mailbox controller.
				The glue which holds everything together.

	Copyright:	1995 Chris K. Thomas.  All Rights Reserved.
	
	Version:	1.0
	
	History:	ckt Jun 27-28, 1995 created.
*/

extern void RegisterUsDammit(); // from PPRegister

#include <PP_Messages.h>
#include <UMemoryMgr.h>
#include <UDrawingState.h>
#include <LGrowZone.h>
#include <LWindow.h>
#include <LStdControl.h>

#include "PPColorPicker.h"

#include "PPColorApp.h"

const PaneIDT	colorPaneID		= 'colr';
const MessageT	msg_SetColor	= 'setc';

// ѥ Lifetime 

PPColorApp::PPColorApp()
{
	// * register PPob stuff
	RegisterUsDammit();
	
}

PPColorApp::~PPColorApp()
{
	
}

// ѥ Responding To AppleEvents 

void PPColorApp::StartUp()
{
	mWindow = LWindow::CreateWindow(128, this);

	ThrowIfNULL_(mWindow);
	
	LPane		*thePane = mWindow->FindPaneByID(msg_SetColor);
	ThrowIfNULL_(thePane);
	
	// * we finally get typesafety, yes!
	LStdButton	*ourButton = dynamic_cast<LStdButton *>(thePane);
	ThrowIfNULL_(ourButton);
	
	ourButton->AddListener(this);

	LApplication::StartUp();
}

// * should openMailBoxWindow on appropriate 

// ѥ Responding To Commands 
#pragma mark  Command Responses

void PPColorApp::ListenToMessage(MessageT inMessage, void */*ioParam*/)
{
	switch (inMessage)
	{
		case msg_SetColor:
			LPane *ourPane = mWindow->FindPaneByID(colorPaneID);
			ThrowIfNULL_(ourPane);
			
			RGBColor	begin = {0xffff, 0xffff, 0xffff};
			
			new PPColorPicker(ourPane, "\pPick a colour, do.", begin, true, false);
			break;
	}
}

// ѥ Handling Commands
#pragma mark  Command Handling
Boolean
PPColorApp::ObeyCommand(
	CommandT	inCommand,
	void		*ioParam)
{
	Boolean		cmdHandled = true;

	switch (inCommand) {
		case cmd_About:
			break;
		case cmd_New:
		{
		} break;
			
		case cmd_Open:
		{
		} break;
		default:
			cmdHandled = LApplication::ObeyCommand(inCommand, ioParam);
			break;
	}
	
	return cmdHandled;
}

// ---------------------------------------------------------------------------
//		 FindCommandStatus
// ---------------------------------------------------------------------------
//	This function enables menu commands.
//

void
PPColorApp::FindCommandStatus(
	CommandT	inCommand,
	Boolean		&outEnabled,
	Boolean		&outUsesMark,
	Char16		&outMark,
	Str255		outName)
{

	switch (inCommand) {
		case cmd_About:
			//enable the damn apple menu
			outEnabled = true;
			outUsesMark = false;
			break;
		
//		case cmd_NewMailbox:
		case cmd_Open:
		case cmd_New:
			outEnabled = true;			// enable the New command
			outUsesMark = false;		// but it doesn't have a checkmark etc.
			break;
		
		default:
			LApplication::FindCommandStatus(inCommand, outEnabled,
												outUsesMark, outMark, outName);
			break;
	}
}

// ѥ Main
#pragma mark  main()

void main(void)
{
/*typedef enum {
	debugAction_Nothing				= 0,
	debugAction_Alert				= 1,
	debugAction_LowLevelDebugger	= 2,
	debugAction_SourceDebugger		= 3
} EDebugAction;*/
									// Set Debugging options
#ifdef Debug_Throw
	gDebugThrow = debugAction_Alert;
#endif

#ifdef Debug_Signal
	gDebugSignal = debugAction_Alert;
#endif

	try
	{
		InitializeHeap(4);
		UQDGlobals::InitializeToolbox(&qd);
		new LGrowZone(20000);
	
		PPColorApp	theApp;			// replace this with your App type
		theApp.Run();
	}
	catch(long inErr)
	{
//		SysBeep(32);
//		SysBeep(32);
//		SmallNoteAlert("\pUncaught error: ", inErr);
	}
	catch(...)
	{
	}
}
