/*
	File:		SprocketColorPicker.cp

	Contains:	Template code for molding to your own app's
				desires.
			
	Written by: Chris Thomas

	Copyright:	 1995 Chris K. Thomas. All Rights Reserved.

	Change History (most recent first):
	 			8/26/95		ckt		Created
*/

#include "EventDesireQ.h"
#include "SprocketColorPicker.h"
#include "MenuBar.h"


// ѥConstructor
//   build self

SprocketColorPicker::SprocketColorPicker(StringPtr inPrompt, RGBColor inOldColor
											Boolean isMovable, Boolean isModal)
:LColorPicker(inPrompt, inOldColor, isMovable, isModal)
{
	mEventDesireIndex = DesireEvent((EventDesiringProc) EventDesireProc, (long) this);
}

// ѥDestructor
//   kill self
SprocketColorPicker::~SprocketColorPicker()
{
	DesireQuenched(mDesireIndex);
}

// ѥGetMenuItems
//   fill in menu item info - change for your app!
void SprocketColorPicker::GetMenuItems(PickerMenuItemInfo &outInfo);
{
	if(gMenuBar)
	{
		// * In Sprocket, we can grab the edit menu indexes automatically
		MenuID	menuID = NULL;
		
		GetMenuAndItem(cUndo, &ourInfo.mInfo.editMenuID, &ourInfo.mInfo.undoItem);
		GetMenuAndItem(cCut, &ourInfo.mInfo.editMenuID, &ourInfo.mInfo.cutItem);
		GetMenuAndItem(cCopy, &ourInfo.mInfo.editMenuID, &ourInfo.mInfo.copyItem);
		GetMenuAndItem(cPaste, &ourInfo.mInfo.editMenuID, &ourInfo.mInfo.pasteItem);
		GetMenuAndItem(cClear, &ourInfo.mInfo.editMenuID, &ourInfo.mInfo.clearItem);
	}
	else
		throw 'nilp';
}

// ѥUserChangingColor
//   called on the fly, while the user is selecting new colors.
//     don't save the color permanently, as the user could cancel it.
void SprocketColorPicker::UserChangingColor()
{
	RGBColor	currentColor;
	
	GetColor(currentColor);
	
	// ...
}

// ѥUserFinalizedColor
//   called when the user has picked a color
//     you still might not save this permanently as the user might click cancel
void SprocketColorPicker::UserFinalizedColor()
{
	RGBColor	currentColor;
	
	GetColor(currentColor);
	
	// ...
}

// ѥUserSaysOK
//   user clicked OK
void SprocketColorPicker::UserSaysOK()
{
	// remove your app's reference(s) to this class
	delete this;
}


// ѥUserSaysCancel
//   user clicked Cancel
void SprocketColorPicker::UserSaysCancel()
{
	// remove your app's reference(s) to this class
	delete this;
}

// ѥEventDesireProc
//   event handler for Sprocket
Boolean SprocketColorPicker::EventDesireProc(EventRecord *inEvent, SprocketColorPicker *data)
{
	data->HandleEvent(inEvent);
}