/*
	File:		AppColorPicker.cp

	Contains:	Template code for molding to your own app's
				desires.
			
	Written by: Chris Thomas

	Copyright:	 1995 Chris K. Thomas. All Rights Reserved.

	Change History (most recent first):
	 			8/26/95		ckt		Created
*/

#include "AppColorPicker.h"

// ѥGetMenuItems
//   fill in menu item info - change for your app!
void AppColorPicker::GetMenuItems(PickerMenuItemInfo &outInfo);
{
	// * these values are intended for standard menus
	// * with just the one "undo" item and then divider
	// * before the rest of the items
	
	ourInfo.mInfo.editMenuID = 130;
	
	ourInfo.mInfo.cutItem = 3;
	ourInfo.mInfo.copyItem = 4;
	ourInfo.mInfo.pasteItem = 5;
	ourInfo.mInfo.clearItem = 6;
	ourInfo.mInfo.undoItem = 1;
}

// ѥUserChangingColor
//   called on the fly, while the user is selecting new colors.
//     don't save the color permanently, as the user could cancel it.
void AppColorPicker::UserChangingColor()
{
	RGBColor	currentColor;
	
	GetColor(currentColor);
	
	// ...
}

// ѥUserFinalizedColor
//   called when the user has picked a color
//     you still might not save this permanently as the user might click cancel
void AppColorPicker::UserFinalizedColor()
{
	RGBColor	currentColor;
	
	GetColor(currentColor);
	
	// ...
}

// ѥUserSaysOK
//   user clicked OK
void AppColorPicker::UserSaysOK()
{
	// remove your app's reference(s) to this class
	delete this;
}


// ѥUserSaysCancel
//   user clicked Cancel
void AppColorPicker::UserSaysCancel()
{
	// remove your app's reference(s) to this class
	delete this;
}