/*

	HighLevelTCP.h

	high-level TCP I/O functions.

	11/28/95 mc - Created.
	12/04/95 dn - Modified for inclusion in Apprentice 4.
*/

#pragma once

#ifndef __HL_TCP_H
#define __HL_TCP_H

#include <MyTCPIncludes.h>

#ifdef __cplusplus
extern "C" {
#endif

OSErr tcpCreate(StreamPtr *stream,ProcPtr tcpNotifyProc,Ptr buffer, long bufsize);
OSErr tcpConnect(StreamPtr stream,ip_addr host,short port,short timeout);
OSErr tcpSend(StreamPtr stream,Ptr data,unsigned short len,Boolean push,Boolean urgent);
OSErr tcpRead(StreamPtr stream,Ptr data,unsigned short *len);
OSErr tcpNoCopyRcv(StreamPtr stream,TCPiopb *tcp,short rdsLen,rdsEntry *rds);
OSErr tcpReturnBuffers(StreamPtr stream,rdsEntry *rds);

OSErr tcpRelease(StreamPtr stream, Ptr *buffer, long *bufsize);
OSErr tcpAbort(StreamPtr stream);
OSErr tcpClose(StreamPtr stream);

#ifdef __cplusplus
}
#endif

#endif
