/*
	IP.c
	
	Code to implement the IP functions.
	
	01/30/94 dn - Created.
	11/28/94 mc - Converted to CodeWarrior
	12/04/95 dn - Prep'd for Apprentice 4
*/

#include <MyTCPIncludes.h>

/*
	IP_EchoICMP
	
	Allows a host to determine whether a remote host is operational without bringing up a protocal like TCP
	or UDP.  IP_EchoICMP can also be used to determine the responsiveness of a network.
*/
OSErr IP_EchoICMP(ICMPParamBlock* pb,Boolean async){
	
	if (pb->ioCRefNum==0)
		return ipNilRefNum;
		
	pb->csCode=ipctlEchoICMP;
	
	return SyncAsync((ParmBlkPtr)pb,async);
}

/*
	IP_LAPStats
	
	Returns the statistics kept by MacTCP on the LAP (Link Access Protocol).
*/
OSErr IP_LAPStats(ICMPParamBlock* pb,Boolean async){
	
	if (pb->ioCRefNum==0)
		return ipNilRefNum;
	
	pb->csCode=ipctlLAPStats;
	
	return SyncAsync((ParmBlkPtr)pb,async);
}