/*
	UDP Probe.h
	
	Header file for UDP Probe.c
	
*/

#pragma once

#ifndef __H_UDP_Probe__
#define __H_UDP_Probe__

#define kMBar			128
#define kMApple		128
#define	kMAbout			1
#define kMFile			129
#define	kMProbe			1
#define	kMQuit			3

// Other Constants...
#define kWindNoStorage	((Ptr)0L)
#define kWindInFront		((WindowPtr)-1)

#ifndef normal
#define normal			0	/* text face normal */
#endif

extern Boolean gQuit;
extern short gMacTCP;

#ifdef __cplusplus
extern "C" {
#endif

// General routines
void main(void);
OSErr InitToolbox(void);
OSErr Initialize(void);
OSErr CleanUp(void);
OSErr MainLoop(void);

// Special TCP/Resolver routines
pascal void ResolverDone(HostInfoPtr rp,char* userData);

// AppleEvent routines
OSErr InitializeAppleEvents(void);
pascal OSErr HandleOApp(AppleEvent* ae,AppleEvent* reply,long refCon);
pascal OSErr HandleODoc(AppleEvent* ae,AppleEvent* reply,long refCon);
pascal OSErr HandlePDoc(AppleEvent* ae,AppleEvent* reply,long refCon);
pascal OSErr HandleQuit(AppleEvent* ae,AppleEvent* reply,long refCon);
OSErr NotHandledEvent(AppleEvent* ae);
OSErr HandleMissedParams(AppleEvent* ae);
OSErr HandleRequiredParams(AppleEvent* ae);

// Event Handling Procedures
OSErr HandleEvent(EventRecord* er);
OSErr HandleLimitedMouse(EventRecord* er,short* part,Boolean* hand);
OSErr HandleMouse(EventRecord* er);
OSErr HandleKey(EventRecord* er);
OSErr HandleActivateEvt(EventRecord* er);
OSErr HandleUpdate(EventRecord* er);
OSErr HandleDisk(EventRecord* er);
OSErr HandleHighLevelEvent(EventRecord* er);
OSErr HandleActivate(EventRecord* er);
OSErr HandleDeactivate(EventRecord* er);
OSErr HandleMouseMoved(EventRecord* er);

// Menu Routines
OSErr HandleMenuEnabling(void);
OSErr HandleMenu(long ms);
OSErr HandleApple(short item);
OSErr HandleFile(short item);
OSErr HandleEdit(short item);

// Support Routines
OSErr HandleError(StringPtr errStr,OSErr err);
OSErr HandleLongError(StringPtr errStr,long err);

OSErr HandleAbout(void);

OSErr NewProbeDialog(void);
OSErr HandleProbeDialog(EventRecord* erp,DialogPtr dlg,short item);

#ifdef __cplusplus
}
#endif

#endif /* __H_UDP_Probe__ */



