unit NoForceQuit;

interface

	procedure InitNoForceQuit;
	procedure FinishNoForceQuit;

{ In the asm file: }
	procedure AsmInitNoForceQuit (sys6byte: ptr; oldsyserror: longInt);
	procedure NoForceQuit;

implementation

	uses
		Traps;

	var
		sys6byte: ptr;
		oldsyserror: longInt;

	procedure InitNoForceQuit;
	begin
		oldsyserror := GetTrapAddress(_SysError);
		sys6Byte := NewPtrSys(6);
		AsmInitNoForceQuit(sys6byte, oldsyserror);
		SetTrapAddress(ord(@NoForceQuit), _SysError);
	end;

	procedure FinishNoForceQuit;
	begin
		BlockMove(@oldsyserror, ptr(ord(sys6byte) + 2), 4);
		FlushDataCache;
		FlushInstructionCache;
	end;

end.