unit MyButtons;

interface

	uses
		Dialogs;
		
	procedure GrayButton (dlg: dialogPtr; item: integer);
	procedure UngrayButton (dlg: dialogPtr; item: integer);
	procedure UpdateButton (dlg: dialogPtr; item: integer; active: boolean);
	procedure InitButton (dlg: dialogPtr; item: integer; var active: boolean; new: boolean);
	procedure SetButton (dlg: dialogPtr; item: integer; var active: boolean; new: boolean);

implementation

	uses
		MyTypes;
		
	procedure GrayButton (dlg: dialogPtr; item: integer);
		var
			kind: integer;
			h: handle;
			r: rect;
			ps: PenState;
	begin
		GetDialogItem(dlg, item, kind, h, r);
		InsetRect(r, 4, 2);
		GetPenState(ps);
		PenPat(GetQDGlobals^.gray);
		PenMode(patBic);
		PaintRoundRect(r, 3, 3);
		SetPenState(ps);
	end;

	procedure UngrayButton (dlg: dialogPtr; item: integer);
		var
			kind: integer;
			h: handle;
			r: rect;
	begin
		GetDialogItem(dlg, item, kind, h, r);
		Draw1Control(controlHandle(h));
	end;

	procedure UpdateButton (dlg: dialogPtr; item: integer; active: boolean);
	begin
		if not active then begin
			GrayButton(dlg, item);
		end;
	end;

	procedure InitButton (dlg: dialogPtr; item: integer; var active: boolean; new: boolean);
		var
			kind: integer;
			h: handle;
			r: rect;
	begin
		active := new;
		GetDialogItem(dlg, item, kind, h, r);
		if active then begin
			HiliteControl(controlHandle(h), 0);
		end else begin
			HiliteControl(controlHandle(h), 255);
			GrayButton(dlg, item);
		end;
	end;

	procedure SetButton (dlg: dialogPtr; item: integer; var active: boolean; new: boolean);
	begin
		if active <> new then begin
			if new then begin
				UngrayButton(dlg, item);
			end else begin
				GrayButton(dlg, item);
			end;
			InitButton(dlg, item, active, new);
		end;
	end;

end.