// Apple sprite for SATcollision][
// No, it has nothing to do with old Apple computers :-)

#include "sC2Apple.h"
#include "sC2MrEgghead.h"

cFace sC2Apple::goodFace = 132;
cFace sC2Apple::badFace = 133;
cFace sC2Apple::coreDump = 135;

cSound sC2Apple::nammSound("\pnamm");
cSound sC2Apple::bliaehSound("\pbliaeh");

sC2Apple::sC2Apple(Point pos)
	:	sSprite(appleGood, pos),
		sBouncer<adjHorz>(RECT(0, 0, gSAT.offSizeH, gSAT.offSizeV))
{
	SetSpeed(POINT(1 + SATRand(3), 0));
	MakeGood();
	SetFace(goodFace);

//	SetHotRect(&rect32);
//	SetRect(&(SpriteStruct()->hotRect), 0,0,32,32);
}

void sC2Apple::Update()
{
	switch (GetKind()) {
		case appleGood: 
			SetFace(goodFace);
			break;
		case appleCorrupt: 
			SetFace(badFace);
			break;
	}
	sBouncer<adjHorz>::Update();
}

void sC2Apple::Hit(sSprite *him)
{
	sC2MrEgghead *egghead = MembExtract(*him, sC2MrEgghead);

	if (!egghead)
		MakeCorrupt();				// Colliding apples corrupt each other!

	// If "him" is not an apple, then it must be the player!
	
	else {
		if (egghead->GoodMood()) {		// if the player feels bad, don't eat
			switch (GetKind()) {
				case appleGood:
					nammSound.Play(1, false);
					egghead->SetMood(25);
					DumpFace(&coreDump, &gBackScreen, TRUE);
					Remove();
					break;
				
				case appleCorrupt: // Bad apple, make player feel bad.
					bliaehSound.Play(2, false);
					egghead->SetMood(-20);
					break;
			}
		}
	}
}

void sC2Apple::Bounced()
{
	if (SATRand(3) == 1)
		MakeCorrupt();
}
