#pragma once

#include <sBouncer.h>
#include <cSound.h>

// Interface to the apple

class sC2Apple : public sBouncer<adjHorz> {
public:
	sC2Apple(Point pos);

	virtual void Update();
	virtual void Hit(sSprite *him);
	virtual void Bounced();
	
	void MakeCorrupt() {
		SetKind(appleCorrupt);
	}
	void MakeGood() {
		SetKind(appleGood);
	}

private:
	// We use kind -2 for fresh apples and kind -3 for bad apples. We avoid -1, since it doesn't count for the "anymonsters" flag.
	// Note that the "kind" field is not modified my SAT since we are not using KindCollision!

	enum {
		appleCorrupt = -3,
		appleGood = -2
	};
	
	static cSound nammSound, bliaehSound;
	static cFace goodFace, badFace, coreDump;
};
