#include <SATcpp.h>

// If your compiler allows you to specify a module to be called for static initializers,
// put a set of #defines in here.  CALL_INITIALIZE should be defined as 1 and
// STATIC_INITIALIZER should be defined to the module to be called to actually do the
// initialization of statics

#define CALL_INITALIZE		0
#define STATIC_INITIALIZER	none

#include <GrafMap.cp>
#include <pixmanip.cp>

const Rect rect32 = {0,0,32,32};
const unsigned char nullStr[] = "\p";

static pascal FacePtr InitNewFace(Rect *rect, Ptr space);
static pascal FacePtr InitGetFace(short iconNum, Ptr space);

pascal FacePtr (*SATNewFaceProc)(Rect *, Ptr) = InitNewFace;
pascal FacePtr (*SATGetFaceProc)(short, Ptr) = InitGetFace;
void (*InitProc)() = Initialize;

#ifdef CALL_INITIALIZE
void __satcpp_init()
{
	Initialize();
	STATIC_INITALIZER();
}
#endif

static void NilProc()
{
}

void ClearMem(void *ptr, short len)
{
	register char *p = (char *) ptr;
	while (len--)
		*(p++) = 0;
}

static pascal FacePtr DoGetFace(short iconNum, Ptr space)
{
	ClearMem(space, sizeof(Face));
	return SATGetFacePP(iconNum, space);
}

static pascal FacePtr DoNewFace(Rect *rect, Ptr space)
{
	ClearMem(space, sizeof(Face));
	return SATNewFacePP(rect, space);
}

void SetFaceLoadProc(void (*proc)())
{
	if (proc) {
		InitProc = proc;
		SATNewFaceProc = InitNewFace;
		SATGetFaceProc = InitGetFace;
	}
	else {
		InitProc = NilProc;
		SATNewFaceProc = DoNewFace;
		SATGetFaceProc = DoGetFace;
	}
}

static pascal FacePtr InitNewFace(Rect *rect, Ptr space)
{
	InitProc();
	return DoNewFace(rect, space);
}

static pascal FacePtr InitGetFace(short iconNum, Ptr space)
{
	InitProc();
	return DoGetFace(iconNum, space);
}

#ifndef CALL_INITIALIZE

class uDummyInit {
public:
	uDummyInit() {
		if (InitProc == Initialize)
			Initialize();
	}
};

static uDummyInit dummyInit;

#endif