#pragma once

#include <Quickdraw.h>
#include <Fonts.h>
#include <Windows.h>
#include <Menus.h>
#include <Dialogs.h>
#include <ToolUtils.h>
#include <Resources.h>
#include <StandardFile.h>

#ifndef TRUE
#define TRUE	1
#endif

#ifndef FALSE
#define FALSE	0
#endif

#ifndef topLeft
#define topLeft(r)	(((Point *) &(r))[0])
#endif

#ifndef botRight
#define botRight(r)	(((Point *) &(r))[1])
#endif

#define SATCPP_H

#include <SAT.h>
#include <PointUtils.h>

extern pascal FacePtr (*SATNewFaceProc)(Rect *, Ptr);
extern pascal FacePtr (*SATGetFaceProc)(short, Ptr);
extern void (*InitProc)();

void Initialize();
void SetFaceLoadProc(void (*proc)());
void ClearMem(void *ptr, short len);

inline void NoFaceLoadProc()
{
	SetFaceLoadProc(0);
}

inline Point MousePos()
{
	Point p;
	GetMouse(&p);
	return p;
}

inline short Abs(short x)
{
	if (x < 0)
		return -x;
	else
		return x;
}

inline void AssignStr(Str255 source, Str255 dest)
{
	short len = *(dest++) = *(source++);
	while (len--)
		*(dest++) = *(source++);
}

inline long Abs(long x)
{
	if (x < 0)
		return -x;
	else
		return x;
}

typedef enum {
	adjHorz,
	adjVert,
	adjBoth
} Adjustment;

typedef ResType Signat;

extern const unsigned char nullStr[];
extern const Rect rect32;