#pragma once

#include <sVecMover.h>

// sBouncer implements a sprite which bounces on the outer boundaries
//
// The template argument determines sides that the sprite can bounce off of:
//
//		adjHorz - left/right
//		adjVert - top/bottom
//		adjBoth - all sides

template <Adjustment a>
class sBouncer : public sVecMover {
public:
	sBouncer(Rect &bounceRect)
		:	sSprite(0, POINT(0,0)) {
		itsBounceRect = bounceRect;
	}	
	virtual void Update() {
		sVecMover::Update();
		if (a != adjHorz)
			if (HoldTop(itsBounceRect.top) || HoldBottom(itsBounceRect.bottom - GetWidth())) {
				ReverseV();
				Bounced();
			}
		if (a != adjVert)
			if (HoldLeft(itsBounceRect.left) || HoldRight(itsBounceRect.right - GetHeight())) {
				ReverseH();
				Bounced();
			}
	}
	virtual void Bounced() {
	}
private:
	Rect itsBounceRect;
};
