#pragma once

#include <sSprite.h>

// sMouseSprite implements a sprite who's position is determined by the mouse position
//
// The template argument determines the axises that the sprite can shift on:
//
//		adjHorz - horizontal axis
//		adjVert - vertical axis
//		adjBoth - both axises

template<Adjustment a>
class sMouseSprite : virtual public sSprite {
public:
	sMouseSprite()
		:	sSprite(0, POINT(0,0)) {
	}
	virtual void Update() {
		SetMousePos();
		if (a != adjVert) {
			HoldLeft(0);
			HoldRight(gSAT.offSizeH - GetWidth());
		}
		if (a != adjHorz) {
			HoldTop(0);
			HoldBottom(gSAT.offSizeV - GetHeight());
		}
	}
};

