{****************************************************}
{}
{		CSATTestApp.p																																																}
{}
{		Application methods for the SATTest application.																							}
{}
{		Copyright  1995 by Patrick C Hew. All rights reserved.																}
{}
{****************************************************}


unit CSATTestApp;

interface

	uses
		TCL, SATTestIntf;

implementation

	const
		kExtraMasters = 4;			(* number of extra master pointer blocks *)
		kRainyDay = 32000;			(* total rainy day memory reserve size	 *)
		kCriticalBalance = 30000;	(* portion of rainy day for critical operations *)
		kToolboxBalance = 20000;	(* portion of rainy day for toolbox reserve *)


{****************************************************}
{}
{		ISATTestApp																																																		}
{}
{		Standard initialization method. See TCL Starter project for explanation of the	}
{		parameters.																																																		}
{}
{****************************************************}

	procedure CSATTestApp.ISATTestApp;

	begin { ISATTestApp }
		IApplication(kExtraMasters, kRainyDay, kCriticalBalance, kToolboxBalance);
	end; { ISATTestApp }


{****************************************************}
{}
{		DoCommand																																																			}
{}
{		Use SATReportStr to put up a simple about box, if desired.															}
{}
{****************************************************}

	procedure CSATTestApp.DoCommand (theCommand: longint);

	begin { DoCommand }
		if theCommand = cmdAbout then begin
				SATReportStr('Sprite Animation Toolkit 2.3b4 used with the THINK Class Library 1.1.2 (Pascal).');
			end; { if }
		inherited DoCommand(theCommand);		{ to handle other commands	}
	end; { DoCommand }


{****************************************************}
{}
{		StartUpAction																																																	}
{}
{		Create the main director and select its window.																								}
{}
{****************************************************}

	procedure CSATTestApp.StartUpAction (numPreloads: Integer);

		var
			theSATDirector: CSATTestDirector;

	begin { StartupAction }
		new(theSATDirector);
		theSATDirector.ISATTestDirector(SELF);
		theSATDirector.BuildWindow;
		theSATDirector.SetUpSprites;
		theSATDirector.SetUpSounds;
		theSATDirector.GetWindow.Select;
	end; { StartupAction }


end. { CSATTestApp }