{****************************************************}
{}
{		SATTestIntf.p																																																	}
{}
{		Interface file for SATTest, which tries out SAT-TCL in a manner similar to			}
{		the tutorial.																																																		}
{}
{		Copyright  1995 by Patrick C Hew. All rights reserved.																}
{}
{****************************************************}


unit SATTestIntf;

interface

	uses
		TCL, SAT, SATTCLIntf, SATTestGlobals, sPlayer, sTarget;

	const

		{ Command IDs. }

		cmdPlayCatch = 2000;

		{ Resource IDs. }

		PICTColorBackground = 128;
		PICTBWBackground = 129;

		WINDSATTest = 500;		{ Resource ID for WIND template 			}


{****************************************************}
{}
{		CSATTestApp																																																	}
{}
{		Application class for the SATTest.																																		}
{}
{****************************************************}

	type
		CSATTestApp = object(CApplication)

				{ Initialization method. }
				procedure ISATTestApp;

				{ Implements a very simple About box. }
				procedure DoCommand (theCommand: longint);
				override;

				{ Creates the SATTest director. }
				procedure StartUpAction (numPreloads: Integer);
				override;

			end;


{****************************************************}
{}
{		CSATTestDirector																																														}
{}
{		Director class for the SATTest.																																				}
{}
{****************************************************}

	type
		CSATTestDirector = object(CSATDirector)

				{ Initialization and destruction. }
				procedure ISATTestDirector (aSupervisor: CApplication);
				procedure Free;
				override;

				{ Setting up things. We put the director in charge of the sounds. }
				procedure BuildWindow;
				override;
				procedure SetUpSprites;
				override;
				procedure SetUpSounds;
				override;

				{ Procedures to make the director, as far as TCL is concerned. }
				procedure UpdateMenus;
				override;
				procedure DoCommand (theCommand: longint);
				override;

				{ Game playing stuff. }
				procedure PrepareForPlaying;
				override;
				procedure DoPlay;
				override;
				procedure FinishPlaying;
				override;

			end;

implementation

end. { SATTestIntf }