property pTLHomeFolder : alias "Flicker:WinterShell:Shared:MyLibraries:ThreadLibrary-1.3:"
global gBuildLibraryObject

-- load script library
on buildLibrary()
	if gBuildLibraryObject = "" then
		set gBuildLibraryObject to load script file "BuildLibrary.as"
	end if
	return gBuildLibraryObject
end buildLibrary

-- Thread Library folders

on homeFolder()
	tell buildLibrary()
		set pTLHomeFolder to findFolder(pTLHomeFolder, "Thread Library")
	end tell
	return pTLHomeFolder
end homeFolder

on executablesFolder()
	return alias ((homeFolder() as string) & "Executables")
end executablesFolder

on librariesFolder()
	return alias ((homeFolder() as string) & "Libraries")
end librariesFolder

on librariesSourceFolder()
	return alias ((homeFolder() as string) & "Source:Libraries")
end librariesSourceFolder

-- Build operations

on build68kLibraries()
	set sourceFolder to librariesSourceFolder()
	set outputFolder to librariesFolder()
	tell buildLibrary()
		buildProject68K("ThreadLibrary.", sourceFolder, outputFolder)
		buildProject68K("ThreadLibrary.dbg.", sourceFolder, outputFolder)
		-- enable these statements when CodeWarrior's CFM68K linker works
		-- buildProject68K("ThreadLibrary.shlb.", sourceFolder, outputFolder)
		-- buildProject68K("ThreadLibrary.dbg.shlb.", sourceFolder, outputFolder)
	end tell
end build68kLibraries

on buildPPCLibraries()
	set sourceFolder to librariesSourceFolder()
	set outputFolder to librariesFolder()
	tell buildLibrary()
		buildProjectPPC("ThreadLibrary.", sourceFolder, outputFolder)
		buildProjectPPC("ThreadLibrary.dbg.", sourceFolder, outputFolder)
		buildProjectPPC("ThreadLibrary.shlb.", sourceFolder, outputFolder)
		buildProjectPPC("ThreadLibrary.dbg.shlb.", sourceFolder, outputFolder)
	end tell
end buildPPCLibraries

on buildTestApplication()
	set execFolder to executablesFolder()
	set testhomeFolder to alias ((homeFolder() as string) & "Source:Demos:ThreadsTest")
	tell buildLibrary()
		buildFatApplication("ThreadsTest.68K.", "ThreadsTest.PPC.", testhomeFolder, execFolder, "ThreadsTest")
	end tell
end buildTestApplication

on buildSpeedTestApplication()
	set execFolder to executablesFolder()
	set timedhomeFolder to alias ((homeFolder() as string) & "Source:Demos:ThreadsTimed")
	tell buildLibrary()
		buildFatApplication("ThreadsTimed.68K.", "ThreadsTimed.PPC.", timedhomeFolder, execFolder, "ThreadsTimed")
	end tell
end buildSpeedTestApplication

on run
	set gBuildLibraryObject to ""
	log "Making Thread Library..."
	build68kLibraries()
	buildPPCLibraries()
	buildTestApplication()
	buildSpeedTestApplication()
	log "Finished making Thread Library."
	beep
end run
