unit WEPascalPPCGlue;

{ WASTE Pascal PPC glue code }
{ version 1.2a3 }

{ RATIONALE: the NewWEProc calls used to create routine descriptors   }
{  for several WASTE callbacks are defined as actual entry points in   }
{  WASTE.p (if generating code for the PPC), but in the C code they're }
{  really only macros.  So when you link a PPC Pascal program to a     }
{  WASTE library built from C code, you'll want to include this glue   }
{  file to avoid link errors.                                          }

{ Copyright  1993-1995 Marco Piovanelli }
{ All Rights Reserved }

interface
	uses
		WASTE;

implementation

{$IFC GENERATINGCFM}
{$PUSH}
{$Z+}

	function NewWEClickLoopProc (userRoutine: WEClickLoopProcPtr): WEClickLoopUPP;
	begin
		NewWEClickLoopProc := NewRoutineDescriptor(userRoutine, uppWEClickLoopProcInfo, GetCurrentArchitecture);
	end;  { NewWEClickLoopProc }

	function NewWEScrollProc (userRoutine: WEScrollProcPtr): WEScrollUPP;
	begin
		NewWEScrollProc := NewRoutineDescriptor(userRoutine, uppWEScrollProcInfo, GetCurrentArchitecture);
	end;  { NewWEScrollProc }

	function NewWETSMPreUpdateProc (userRoutine: WETSMPreUpdateProcPtr): WETSMPreUpdateUPP;
	begin
		NewWETSMPreUpdateProc := NewRoutineDescriptor(userRoutine, uppWETSMPreUpdateProcInfo, GetCurrentArchitecture);
	end;  { NewWETSMPreUpdateProc }

	function NewWETSMPostUpdateProc (userRoutine: WETSMPostUpdateProcPtr): WETSMPostUpdateUPP;
	begin
		NewWETSMPostUpdateProc := NewRoutineDescriptor(userRoutine, uppWETSMPostUpdateProcInfo, GetCurrentArchitecture);
	end;  { NewWETSMPostUpdateProc }

	function NewWETranslateDragProc (userRoutine: WETranslateDragProcPtr): WETranslateDragUPP;
	begin
		NewWETranslateDragProc := NewRoutineDescriptor(userRoutine, uppWETranslateDragProcInfo, GetCurrentArchitecture);
	end;  { NewWETranslateDragProc }

	function NewWEDrawTextProc (userRoutine: WEDrawTextProcPtr): WEDrawTextUPP;
	begin
		NewWEDrawTextProc := NewRoutineDescriptor(userRoutine, uppWEDrawTextProcInfo, GetCurrentArchitecture);
	end;  { NewWEDrawTextProc }

	function NewWEPixelToCharProc (userRoutine: WEPixelToCharProcPtr): WEPixelToCharUPP;
	begin
		NewWEPixelToCharProc := NewRoutineDescriptor(userRoutine, uppWEPixelToCharProcInfo, GetCurrentArchitecture);
	end;  { NewWEPixelToCharProc }

	function NewWECharToPixelProc (userRoutine: WECharToPixelProcPtr): WECharToPixelUPP;
	begin
		NewWECharToPixelProc := NewRoutineDescriptor(userRoutine, uppWECharToPixelProcInfo, GetCurrentArchitecture);
	end;  { NewWECharToPixelProc }

	function NewWELineBreakProc (userRoutine: WELineBreakProcPtr): WELineBreakUPP;
	begin
		NewWELineBreakProc := NewRoutineDescriptor(userRoutine, uppWELineBreakProcInfo, GetCurrentArchitecture);
	end;  { NewWELineBreakProc }

	function NewWENewObjectProc (userRoutine: WENewObjectProcPtr): WENewObjectUPP;
	begin
		NewWENewObjectProc := NewRoutineDescriptor(userRoutine, uppWENewObjectProcInfo, GetCurrentArchitecture);
	end;  { NewWENewObjectProc }

	function NewWEDisposeObjectProc (userRoutine: WEDisposeObjectProcPtr): WEDisposeObjectUPP;
	begin
		NewWEDisposeObjectProc := NewRoutineDescriptor(userRoutine, uppWEDisposeObjectProcInfo, GetCurrentArchitecture);
	end;  { NewWEDisposeObjectProc }

	function NewWEDrawObjectProc (userRoutine: WEDrawObjectProcPtr): WEDrawObjectUPP;
	begin
		NewWEDrawObjectProc := NewRoutineDescriptor(userRoutine, uppWEDrawObjectProcInfo, GetCurrentArchitecture);
	end;  { NewWEDrawObjectProc }

	function NewWEClickObjectProc (userRoutine: WEClickObjectProcPtr): WEClickObjectUPP;
	begin
		NewWEClickObjectProc := NewRoutineDescriptor(userRoutine, uppWEClickObjectProcInfo, GetCurrentArchitecture);
	end;  { NewWEClickObjectProc }
	
	function NewWEStreamObjectProc (userRoutine: WEStreamObjectProcPtr): WEStreamObjectUPP;
	begin
		NewWEStreamObjectProc := NewRoutineDescriptor(userRoutine, uppWEStreamObjectProcInfo, GetCurrentArchitecture);
	end;  { NewWEStreamObjectProc }

{$POP}
{$ENDC}

end.